package java.util;
public interface Collection
{

    //@ public model instance non_null JMLEqualsBag theCollection;

    //@ instance ghost public \TYPE elementType;

    //@ public instance invariant elementType == theCollection.elementType; 
    //@ instance ghost public boolean containsNull;
    //@ public instance invariant containsNull == theCollection.containsNull;


  boolean add(Object o);

  boolean addAll(Collection c);

    /*@ public behavior
      @   assignable theCollection;
      @   ensures theCollection.isEmpty();
      @   ensures_redundantly size() == 0;
      @   signals (UnsupportedOperationException);
      @*/
  void clear();

  boolean contains(Object o);

  boolean containsAll(Collection c);

  boolean equals(Object o);

  int hashCode();

  boolean isEmpty();

    /*@ public normal_behavior
      @   assignable \nothing;
      @   ensures \result != null;
      @   ensures \result.elementType == elementType;
      @   ensures containsNull == \result.returnsNull;
      @   ensures (\forall int i; 0 <= i && i < size();
      @                 theCollection.has(\result.nthNextElement(i)));
      @   ensures (\forall Object o; theCollection.has(o) ==>
      @              (\exists int i; 0 <= i && i < size(); 
      @                 o == \result.nthNextElement(i)));
      @   ensures size() > 0 ==> \result.hasNext((int)(size()-1));
      @   ensures !\result.hasNext((int)(size()));
      @   ensures_redundantly
      @           (\forall int i; 0 <= i && i < size();
      @                 this.contains(\result.nthNextElement(i)));
      @   ensures_redundantly size() != 0 ==> \result.moreElements;
      @*/
  Iterator iterator();

    /*@ public behavior
      @   requires !containsNull ==> o != null;
      @   requires  (o == null) || \typeof(o) <: elementType;
      @   assignable theCollection;
      @   ensures \result
      @         ==> theCollection.equals(\old(theCollection.remove(o)));
      @   ensures \result && \old(size() <= Integer.MAX_VALUE)
      @           ==> size() == \old(size()-1) && size() < Integer.MAX_VALUE
      @               && size() >= 0;
      @   ensures !\result || \old(size() == Integer.MAX_VALUE)
      @           ==> size() == \old(size());
      @   signals (UnsupportedOperationException);
      @   signals (ClassCastException);
      @*/
  boolean remove(Object o);

  boolean removeAll(Collection c);

  boolean retainAll(Collection c);

    /*@ public normal_behavior
      @   assignable \nothing;
      @   ensures \result == theCollection.int_size();
      @
      @ also normal_behavior
      @    ensures \result >= 0;
      @*/
  int size();

  Object[] toArray();

  Object[] toArray(Object[] a);
}
